/* 

    Simple X11 capture monitor.

    Copyright 2007-2013 by David Santinoli <david@santinoli.com>
*/

#include <X11/Xlib.h>
#include <Imlib2.h>
#include "video.h"

static Display *disp;
static Window win;
static Visual  *vis;
static Colormap cm;
static int depth;

static Imlib_Image im;
static unsigned char *rebuf;

int x11_monitor_init(int capx, int capy)
{
 XSetWindowAttributes attr;

 disp=XOpenDisplay(NULL);
 vis   = DefaultVisual(disp, DefaultScreen(disp));
 depth = DefaultDepth(disp, DefaultScreen(disp));
 cm    = DefaultColormap(disp, DefaultScreen(disp));
 win = XCreateSimpleWindow(disp, DefaultRootWindow(disp),
                             0, 0, capx, capy, 0, 0, 0);

 XMapWindow(disp,win);
 //XSync(disp,False);
 XStoreName(disp,win,"Eye of Palantir");

 imlib_context_set_display(disp);
 imlib_context_set_visual(vis);
 imlib_context_set_colormap(cm);
 imlib_context_set_drawable(win);

 rebuf=malloc(capx*capy*4);

 return 0;
}

void x11_monitor(unsigned char *buf, int capx, int capy)
{
 unsigned char *in=buf, *out=rebuf;
 int i;
 /* RGB -> BGRA */
 for(i=0;i<capx*capy*3;i+=3,in+=3) {
    *out++=in[2];
    *out++=in[1];
    *out++=in[0];
    *out++=0;
    }

 im=imlib_create_image_using_data(capx,capy,rebuf);
 imlib_context_set_image(im);
 imlib_render_image_on_drawable(0,0);
 imlib_free_image();
}
